module MapHelper
  def map_setup_script(lat=nil,lon=nil, zoom=15)
    "var mapnikmapde = L.tileLayer('http://{s}.tile.openstreetmap.de/tiles/osmde/{z}/{x}/{y}.png', { attribution: '&copy; <a href=\"http://www.openstreetmap.org/copyright\">OpenStreetMap</a> contributors'});
    var mapnikmaporg = L.tileLayer('http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', { attribution: '&copy; <a href=\"http://www.openstreetmap.org/copyright\">OpenStreetMap</a> contributors'});
    var mtbmap = L.tileLayer('http://tile.mtbmap.cz/mtbmap_tiles/{z}/{x}/{y}.png', { attribution: '&copy; <a href=\"http://www.openstreetmap.org/copyright\">OpenStreetMap</a> contributors &amp; USGS' });;
    var map = L.map('map', {layers: [mtbmap] #{(lat.nil? or lon.nil?) ? '' : ", center: [#{lat},#{lon}], zoom: #{zoom} "}});
    var baseMaps = {
      \"Turistická a cyklo mapa\": mtbmap,
      \"Základní mapa light\": mapnikmapde,
      \"Základní mapa\": mapnikmaporg
    };
    L.control.layers(baseMaps).addTo(map);".html_safe
  end
  
  ## map_marker options:
  ##   :popup_text (string)   co má být v bublině
  ##   :openpopup (boolean)   zda se má předotevřít popup
  ##
  
  def map_marker_add(guidepost, options={});           map_marker(guidepost, options.merge(:addtomap=> true))                  end
  def map_marker_create(guidepost, options={});        map_marker(guidepost, options)                                          end
  def map_circle_marker_create(guidepost, options={}); map_marker(guidepost, options.merge(:circular=>true))                   end # osm_trails/_map
  def map_circle_marker_add(guidepost, options={});    map_marker(guidepost, options.merge(:addtomap=> true, :circular=>true)) end # guidepost/show
  
  def map_marker(guidepost, options={}) 
    lat = guidepost.respond_to?('lat') ? guidepost.lat : guidepost[0]
    lon = guidepost.respond_to?('lon') ? guidepost.lon : guidepost[1]

    text = []
    text << guidepost.nazev if guidepost.respond_to?('nazev')
    text << "rozcestník #{guidepost.kctref}" if guidepost.respond_to?(:kctref)
    text << options[:popup_text]
    text << options[:text]
    text = text.compact.join("<br/>")
    
    (
      "L.circleMarker([#{lat},#{lon}])"+
      (options[:addtomap] ? ".addTo(map)" : '' )+
      (options[:circular] ? ".setRadius(10)" : '')+
      (!text.empty? ? ".bindPopup('#{text}')" : '') +
      (options[:openpopup] ? '.openPopup()' : '')
    ).html_safe
  end

  # debug
  def show_points(array)
    array.collect{|point| show_point(point)}.join().html_safe
  end

  def show_point(point,color='yellow')
    pid = "[#{point[0].round(4)},#{point[1].round(4)}]"
    "<script>
      m = L.circleMarker(#{pid}, { color: '#{color}'}).setRadius(5).bindPopup('#{pid}').addTo(map);
      hashMarkers['#{pid}']= m
     </script>
     <span class='point' id='#{pid}'>#{pid}</span> 
     ".html_safe
  end

  
end
